﻿/*

 * Serial Port Monitor
 *
 * 
 * Original code from http://playground.arduino.cc//Csharp/SerialCommsCSharp
 * Code by Richard210363
 * Code Taken from Website 11/11/13
 * 
 * This code has been modified by 
 * Mario Avenoso (mario@mtechcreations.com) 11/11/13
 * Added to this code was more comments to better enplane how the different
 * parts work. This code was also added to a C# form app. Also, some parts of the code provided
 * have been changed as they where either un needed or did not work
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;



using System.Threading;

using System.IO.Ports;

using System.IO; 

namespace Arduino_test
{
    public partial class Form1 : Form
    {
        SerialPort currentPort;//create serial port object
        bool portFound;//bool for noing if the serail port has been found
        string port_name = "";//name of port, will be set if found in the arduino detect function
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            arduino_c_t.Text = "NO";//sets arduino conneceted to no
            arduino_p_t.Text = "Non";//sets port name to non
            SetComPort();//look for the Serial port as the program starts

            if (portFound)//if the arduino is found, this will be true
            {
                arduino_c_t.Text = "YES";//dispalys yes for connected
                arduino_p_t.Text = port_name;//shows where the arduino is connected
            }
            else//arduino not found
            {
                arduino_c_t.Text = "NO";//keep value
                arduino_p_t.Text = "Non";//keep value
            }
        }

        	

	private void SetComPort()
	{
	    try
	    {
		string[] ports = SerialPort.GetPortNames();//creat array with all port names on computer
		foreach (string port in ports)//for every port (string) from the ports array.
		{
		    currentPort = new SerialPort(port, 9600);//create com port using current name from the array
            //of all com ports, baud rate is 9600

            //MessageBox.Show(port);//debuging

		    if (DetectArduino())//check is the arduino is on this current port
		    {
                //MessageBox.Show("Arduino Found!!!");//debuging
                port_name = port.ToString();//convert the port to a string and then set port_name
			    portFound = true;//set port flag to true
			    break;
		    }
		    else
		    {
               // MessageBox.Show("Arduino Not Found");//debugging
                portFound = false;//set port flag to false
		    }
		}
	    }
	    catch (Exception e)
	    {
            MessageBox.Show("Error!");//show error message is something happend
	    }
	}

	private bool DetectArduino()
	{
	            try
	            {
		        //The below setting are for the Hello handshake
		        byte[] buffer = new byte[5];
		        buffer[0] = Convert.ToByte(16);//start of message
		        buffer[1] = Convert.ToByte(128);//command to tell arduino to say hi
		        buffer[2] = Convert.ToByte(0);//empty command
                buffer[3] = Convert.ToByte(0);//empty command
                buffer[4] = Convert.ToByte(0);//empty command

		        int intReturnASCII = 0;
		        char charReturnValue = (Char)intReturnASCII;

		        currentPort.Open();//open com port connection
		        currentPort.Write(buffer, 0, 5);//send the message from the buffer array
		        Thread.Sleep(1000);//wait, give time for replay

		        int count = currentPort.BytesToRead;//get lenght of replay message
		        string returnMessage = "";
		        while (count > 0)
		        {
		            intReturnASCII = currentPort.ReadByte();
                
		            returnMessage = returnMessage + Convert.ToChar(intReturnASCII);//creat message letter by letter
                    //to create a string
                    //MessageBox.Show(returnMessage);//debuging
		            count--;
		        }
           



                if (returnMessage.Contains("HELLO"))//The Arduino said hello
		        {
                    currentPort.Close();//close the serial com port connection
		            return true;
		        }
		        else//device was either not an arduino, or it didn't say hello
		        {
                    currentPort.Close();//close the serial com port connection
		            return false;
		        }
	        }
	        catch (Exception e)
	        {
             MessageBox.Show("Error, No Arduino");
		    return false;
	        }
      }

    }
}
